﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace UltraGridTreeCrash
{
    static class CompanyCollectionFactory
    {
        static private Random rnd1 = new Random(unchecked((int)(DateTime.Now.Ticks)));

        static private string[] products = { "cats", "dogs", "tv", "vcr", "milk", "bmw z8", "nikon D3s", "cake", "paper" };
        static string[] firstNames = { "James", "John", "Robert", "Michael", "William", "David", "Richard", "Charles", "Joseph", "Thomas", "Christopher", "Daniel", "Paul", "Mark", "Donald", "George", "Kenneth", "Steven", "Edward", "Brian", "Ronald", "Anthony", "Kevin", "Jason", "Matthew", "Gary", "Timothy", "Jose", "Larry", "Jeffrey", "Frank", "Scott", "Eric", "Stephen", "Andrew", "Raymond", "Gregory", "Joshua", "Jerry", "Dennis", "Walter", "Patrick", "Peter", "Harold", "Douglas", "Henry", "Carl", "Arthur", "Ryan", "Roger", "Joe", "Juan", "Jack", "Albert", "Jonathan", "Justin", "Terry", "Gerald", "Keith", "Samuel", "Willie", "Ralph", "Lawrence", "Nicholas", "Roy", "Benjamin", "Bruce", "Brandon", "Adam", "Harry", "Fred", "Wayne", "Billy", "Steve" };
        static string[] lastNames = { "Smith", "Johnson", "Williams", "Jones", "Brown", "Davis", "Miller", "Wilson", "Moore", "Taylor", "Anderson", "Thomas", "Jackson", "White", "Harris", "Martin", "Thompson", "Garcia", "Martinez", "Robinson", "Clark", "Rodriguez", "Lewis", "Lee", "Walker", "Hall", "Allen", "Young", "Hernandez", "King", "Wright" };

        static public CompanyCollection Create()
        {
            CompanyCollection coll = new CompanyCollection();

            coll.Add(new Company 
                { 
                    CompanyName = "A", Address = "123 Main st", City = "Milford", State = "OH", Zip = "45854",
                    Employees = CreateCustomerBindingList(2) 
                });
            coll.Add(new Company 
                { 
                    CompanyName = "B", Address = "95 Broadway", City = "Morgan", State = "OH", Zip = "45154",
                    Employees = CreateCustomerBindingList(3) 
                });
            coll.Add(new Company 
                { 
                    CompanyName = "C", Address = "100 Super Tech Lane", City = "Sunnyvale", State = "CA", Zip = "93581",
                    Employees = CreateCustomerBindingList(4) 
                });
            coll.Add(new Company 
                { 
                    CompanyName = "D", Address = "667 Crashing Code Ave", City = "Baltimore", State = "MA", Zip = "21237", 
                    Employees = CreateCustomerBindingList(5) 
                });

            return coll;
        }


        private static BindingList<Employee> CreateCustomerBindingList(int count)
        {
            BindingList<Employee> coll = new BindingList<Employee>();

            while(count > 0)
            {
                coll.Add(new Employee
                {
                    FirstName = firstNames[rnd1.Next(firstNames.Length - 1)],
                    LastName = lastNames[rnd1.Next(lastNames.Length - 1)],
                    EmployeeNumber = rnd1.Next(200).ToString()
                    ,Orders = CreateOrderBindingList()
                });
                count--;
            }
            return coll;
        }

        private static BindingList<Order> CreateOrderBindingList()
        {
            int orderCnt = rnd1.Next(3)+1;
            BindingList<Order> coll = new BindingList<Order>();
            for (int i = 0; i < orderCnt; i++)
            {
                coll.Add(CreateOrder());
            }

            return coll;
        }

        static int orderNum = 0;

        private static Order CreateOrder()
        {
            Order order = new Order
            {
                OrderNumber = orderNum++,
                OrderDate = DateTime.Now,
                PONumber = rnd1.Next(10000).ToString(),
                OrderLines = new BindingList<OrderLine>()
            };

            for (int i = 0; i < 2; i++)
            {
                OrderLine orderLine = new OrderLine
                {
                    Qty = rnd1.Next(10) + 1,
                    Description = products[rnd1.Next(products.Length)],
                    Price = Math.Round(rnd1.NextDouble() * 500, 2)
                };

                order.OrderLines.Add(orderLine);
            }
            return order;
        }
    }
}


