﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace UltraGridTreeCrash
{
    class OrderLine
    {
        public int Qty { get; set; }
        public double Price { get; set; }
        public string Description { get; set; }
    }

    class Order
    {
        public DateTime OrderDate { get; set; }
        public int OrderNumber { get; set; }
        public string PONumber { get; set; }
        public BindingList<OrderLine> OrderLines { get; set; }
    }

    class Employee
    {
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string EmployeeNumber { get; set; }
        public BindingList<Order> Orders { get; set; }
    }

    class Company
    {
        public string CompanyName { get; set; }
        public string Address { get; set; }
        public string City { get; set; }
        public string State { get; set; }
        public string Zip { get; set; }
        public BindingList<Employee> Employees { get; set; }
    }

    class CompanyCollection : BindingList<Company>
    {
        public CompanyCollection()
        {
            this.AllowEdit = true;
            this.AllowNew = true;
            this.AllowRemove = true;
        }

        /// <summary>
        /// 
        /// </summary>
        public CompanyCollection(IList<Company> coll)
            : base(coll)
        {
            this.AllowEdit = true;
            this.AllowNew = true;
            this.AllowRemove = true;
        }
    }
}
